package models

import (
	"rdluck_tools/orm"
	"time"
)

//type BaseFromTradeDalianIndex struct {
//	BaseFromTradeDalianIndexId int `orm:"column(base_from_trade_dalian_index_id);pk"`
//	IndexName                  string
//	IndexCode                  string
//	Frequency                  string
//	StartDate                  time.Time
//	EndDate                    time.Time
//	CreateTime                 time.Time
//	ModifyTime                 time.Time
//	ClassifyName               string
//	ClassifyType               string
//}

type BaseFromTradeDalianIndex struct {
	BaseFromTradeDalianIndexId int    `orm:"column(base_from_trade_dalian_index_id);pk"`
	Rank                       string `description:"排名"`
	DealShortName              string `description:"成交量公司简称"`
	DealName                   string `description:"成交量指标名称"`
	DealCode                   string `description:"成交量指标编码"`
	DealValue                  string `description:"成交量"`
	DealChange                 string `description:"成交变化量"`
	BuyShortName               string `description:"成交量公司简称"`
	BuyName                    string `description:"持买单量指标名称"`
	BuyCode                    string `description:"持买单量指标编码"`
	BuyValue                   string `description:"持买单量"`
	BuyChange                  string `description:"持买单量变化量"`
	SoldShortName              string `description:"成交量公司简称"`
	SoldName                   string `description:"持买单量指标名称"`
	SoldCode                   string `description:"持买单量指标编码"`
	SoldValue                  string `description:"持买单量"`
	SoldChange                 string `description:"持买单量变化量"`
	Frequency                  string `description:"频度"`
	ClassifyName               string `description:"分类名称"`
	ClassifyType               string `description:"分类名称下的类型"`
	//CreateTime                 time.Time `description:"插入时间"`
	//ModifyTime                 time.Time `description:"修改时间"`
	//DataTime                   time.Time `description:"数据日期"`

	CreateTime string `description:"插入时间"`
	ModifyTime string `description:"修改时间"`
	DataTime   string `description:"数据日期"`
}

func AddBaseFromTradeDalianIndex(item *BaseFromTradeDalianIndex) (lastId int64, err error) {
	o := orm.NewOrm()
	o.Using("data")
	lastId, err = o.Insert(item)
	return
}

//详情
func GetBaseFromTradeDalianIndexInfo(indexName string) (item *BaseFromTradeDalianIndex, err error) {
	o := orm.NewOrm()
	o.Using("data")
	sql := `SELECT * FROM base_from_trade_dalian_index  WHERE index_name=? `
	err = o.Raw(sql, indexName).QueryRow(&item)
	return
}

//获取数量
func GetDalianIndexCountByIndexName(indexName string) (count int, err error) {
	o := orm.NewOrm()
	o.Using("data")
	sqlCount := `SELECT COUNT(1) AS count  FROM base_from_trade_dalian_index  WHERE index_name=?`
	err = o.Raw(sqlCount, indexName).QueryRow(&count)
	return
}

type BaseFromTradeDalianData struct {
	BaseFromTradeDalianDataId  int `orm:"column(base_from_trade_dalian_data_id);pk"`
	BaseFromTradeDalianIndexId int
	IndexCode                  string
	DataTime                   time.Time
	Value                      string
	AddCutValue                string
	CreateTime                 time.Time
	ModifyTime                 time.Time
	DataTimestamp              string
}

func AddBaseFromTradeDalianData(item *BaseFromTradeDalianData) (lastId int64, err error) {
	o := orm.NewOrm()
	o.Using("data")
	lastId, err = o.Insert(item)
	return
}

func GetAddSql(item *BaseFromTradeDalianIndex) (addSql string) {
	addSql += "('" + item.Rank + "','" + item.DealShortName + "','" + item.DealName + "','" + item.DealCode + "','" + item.DealValue + "','" + item.BuyShortName + "','" + item.DealChange + "','" + item.BuyName + "','" + item.BuyCode + "','" + item.BuyValue + "','" + item.BuyChange + "','" + item.SoldShortName + "','" + item.SoldName + "','" + item.SoldCode + "','" + item.SoldValue + "','" + item.SoldChange + "','" + item.Frequency + "','" + item.ClassifyName + "','" + item.ClassifyType + "','" + item.CreateTime + "','" + item.ModifyTime + "','" + item.DataTime + "'),"
	return
}

//刷新大连指标数据
func RefreshEdbDataByDaLian(addSql string) (err error) {
	o := orm.NewOrm()
	o.Using("data")
	_, err = o.Raw(addSql).Exec()
	if err != nil {
		return err
	}
	return
}
